%THIS SOURCE CODE IS SUPPLIED "AS IS" WITHOUT WARRANY OF ANY KIND, AND ITS AUTHOR
%AND THE JOURNAL OF ARTIFICIAL INTELLIGENCE RESEARCH (JAIR) AND JAIR'S
%PUBLISHERS AND DISTRIBUTORS, DISCLAIM ANY AND ALL WARRANTIES, INCLUDING BUT NOT 
%LIMITED TO ANY IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
%PURPOSE, AND ANY WARRANTIES OR NON INFRINGEMENT.  THE USER ASSUMES ALL LIABILITY
%AND RESPONSIBILITY FOR USE OF THIS SOURCE CODE, AND NEITHER THE AUTHOR NOR JAIR, 
%NOR JAIR'S PUBLISHERS AND DISTRIBUTORS, WILL BE LIABLE FOR DAMAGES OF ANY KIND
%RESULTING FROM ITS USE. WITHOUT LIMITING THE GENERALITY OF THE FOREGOING, NEITHER 
%THE AUTHOR, NOR JAIR, NOR JAIR'S PUBLISHERS AND DISTRIBUTORS, WARRANT THAT THE
%SOURCE CODE WILL BE ERROR-FREE, WILL OPERATE WITHOUT INTERRUPTION, OR WILL MEET 
%THE NEEDS OF THE USER.

function F = policy_test(X,Y)
% SUMMARY: This function uses state-action pairs and their associated
%   Q-values to create a policy on the go, test that policy, and create a
%   movie of the resulting trajectory
% INPUT: X is an Nx3 matrix of state-actions. Positions are in the first
%   column, velocities are in the second column, and actions are in the
%   third
% OUTPUT: Y is an Nx1 vector of state-action values

% create configuration object 
config = classconfig();
test_steps = 500;
state = [-.5, 0];
for k=1:test_steps
    % create a picture describing current position
    create_figure(state(1));
    % this is used to play a movie of the trajectory
    F(k) = getframe;
    [~, action] = findpartialproductkernelmax(X,Y,config.bandwidth,state,config.action_bounds(1),config.action_bounds(2));    
    [next_state, ~, fail_flag, success_flag] = transition_reward(state,action);
    if fail_flag
        % terminate test
        break
    elseif success_flag
        % terminate test
        break
    else
        % carry on
        state = next_state;
    end
end
movie(F,1)
