%THIS SOURCE CODE IS SUPPLIED "AS IS" WITHOUT WARRANY OF ANY KIND, AND ITS AUTHOR
%AND THE JOURNAL OF ARTIFICIAL INTELLIGENCE RESEARCH (JAIR) AND JAIR'S
%PUBLISHERS AND DISTRIBUTORS, DISCLAIM ANY AND ALL WARRANTIES, INCLUDING BUT NOT 
%LIMITED TO ANY IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
%PURPOSE, AND ANY WARRANTIES OR NON INFRINGEMENT.  THE USER ASSUMES ALL LIABILITY
%AND RESPONSIBILITY FOR USE OF THIS SOURCE CODE, AND NEITHER THE AUTHOR NOR JAIR, 
%NOR JAIR'S PUBLISHERS AND DISTRIBUTORS, WILL BE LIABLE FOR DAMAGES OF ANY KIND
%RESULTING FROM ITS USE. WITHOUT LIMITING THE GENERALITY OF THE FOREGOING, NEITHER 
%THE AUTHOR, NOR JAIR, NOR JAIR'S PUBLISHERS AND DISTRIBUTORS, WARRANT THAT THE
%SOURCE CODE WILL BE ERROR-FREE, WILL OPERATE WITHOUT INTERRUPTION, OR WILL MEET 
%THE NEEDS OF THE USER.

function roots = solvequadratic(a,b,c)
% SUMMARY: Finds roots of a quadratic, just like grade school
% INPUT: numbers a, b, and c for the quadratic ax^2 + bx + c
% OUTPUT: roots of the related quadratic.  roots is empty if 
%   roots are imaginary or a=b=0

if a == 0
    if b == 0
        roots = [];        
    else
        roots = -c/b;
    end
elseif (b^2 - 4*a*c < 0)
    roots = [];
else
    roots=zeros(1,2);
    roots(1) = (-b + (b^2 - 4*a*c)^.5)/(2*a);
    roots(2) = (-b - (b^2 - 4*a*c)^.5)/(2*a);
end

